# test

def data(I, k, beta):
  global x
  return I*(np.sin(k*x)/k/x)**2*(np.cos(beta*x))**2

if __name__=="__main__":
  x_size=1000; TrainN=10000; validN=50; testN=10
  x=np.linspace(-1e-2, 1e-2, x_size)
  # Eval
  model.eval()
  I1=np.random.uniform(0, 1e2, testN)
  k1=np.random.uniform(0, 1e3, testN)
  beta1=np.random.uniform(0, 1e4, testN)

  plt.figure(figsize=(7, 7*testN))
  for i in range(testN):
    label_test=torch.tensor([I1[i], k1[i], beta1[i]]).view(1, 3)
    attr_test=torch.tensor(data(I1[i], k1[i], beta1[i]), dtype=torch.float32)
    pred=model(attr_test)[0]

    plt.subplot(testN, 1, i+1)
    plt.plot(x, attr_test, color="#00a3d2", alpha=0.5)
    plt.plot(x, data(pred[0].detach(), pred[1].detach(), pred[2].detach()), color="#881824", alpha=0.5)
    plt.xlabel("screen"); plt.ylabel("Intensity")
    ylarge=np.max((I1[i], pred[0].detach()))
    plt.text(0, ylarge*(4/5), "label) I: %d, k: %d, beta: %d"%(I1[i], k1[i], beta1[i]), weight="bold")
    plt.text(0, ylarge*(3/5), "predi) I: %d, k: %d, beta: %d"%(pred[0], pred[1], pred[2]), weight="bold")
    plt.xticks([-1e-2, 0, 1e-2]); plt.yticks([0, ylarge//2, ylarge])
  
  plt.show()
